program MicrosAp;

{-----------------------------------------------------------------------
Example application for the MicroScroll (MICROS.DLL) of the SMWCC 2.0
Custom Control Pack

Copyright (C) Sebastian Modersohn

Note: This code file isn't documented into detail. If you have
      questions to *THIS* code file or want to know some details
      please contact me via CompuServe, ID 100340,1474.
-----------------------------------------------------------------------}

{$IFNDEF AUTOLOAD}

  You HAVE to compile this program with the global defined symbol "AUTOLOAD" !
  This demonstrates the autoloading feature of the import unit Micro!
{$ENDIF}

{$R MicrosAp}

uses WinTypes, WinProcs, Win31, Objects, OWindows, ODialogs, BWCC,
     {Interface unit of the control}
     Micro, MicroCo;

type
  PMicroWindow = ^TMicroWindow;
  TMicroWindow = object(TDlgWindow)
    AEC: PMicroEC;
    MyMicro: PMicro;
    constructor Init(AParent: PWindowsObject; AName: PChar);

    procedure Enable(var Msg: TMessage);
      virtual id_First + 301;
    procedure Disable(var Msg: TMessage);
      virtual id_First + 302;
    procedure Help(var Msg: TMessage);
      virtual id_First + idHelp;
  end;

  {App that initializes the main window}
  PMicroApp = ^TMicroApp;
  TMicroApp = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

{ TMicroWindow }

constructor TMicroWindow.Init(AParent: PWindowsObject; AName: PChar);
begin
  inherited Init(AParent, AName);
  {Init a PEdit descendant which is corresponding with the micro
  Id: 201, Micro: nil, From: 0, To: 10, Step: 1, Start: 4, Unit: inch}
  AEC:=New(PMicroEC, InitResource(@Self, 201, nil, 0, 10, 1, 4, ' inch'));

  {Init a MicroScroll which is corresponding with the Edit (AEC)
  Id: 202, Edit: AEC!!}
  MyMicro:=New(PMicro, InitResource(@Self, 202, AEC));

  {Tell the Edit (AEC) which MicroScroll is corresponding with it}
  AEC^.Micro:=MyMicro;
end;

procedure TMicroWindow.Enable(var Msg: TMessage);
begin
  EnableWindow(GetDlgItem(HWindow, 202), True);
end;

procedure TMicroWindow.Disable(var Msg: TMessage);
begin
  EnableWindow(GetDlgItem(HWindow, 202), False);
end;

procedure TMicroWindow.Help(var Msg: TMessage);
begin
  WinHelp(HWindow, HelpFile, Help_Context, 100);
end;

{ TMicroApp }

procedure TMicroApp.InitMainWindow;
begin
  MainWindow := New(PMicroWindow, Init(nil, MakeIntResource(100)));
end;

var App: TMicroApp;

begin
  App.Init('MicroScroll Demo');
  App.Run;
  App.Done;
end.
